/*****************************************************************************
 * Blink_Code.c
 *****************************************************************************/
#include <sru.h>
#include <def21479.h>
#include <cdef21479.h>
#include <initPLL.h>
#include <signal.h>

asm("#include <def21479.h>");

extern void InitSRU(void);
void BlinkLED(void );
void General_Purpose_Timer0_Isr(int dummy);
void InitTimers(void);

int toggle_flag = 0;
int	Period_measured = 0;
int	Count_measured = 0;
int count = 0;

// initPLL_2148x(mult,divider, SDCKR, Indiv);
// mult = 0 to 64
// Divider = 0 to 3 (0- 2, 1 - 4, 2-8, 3-16)
// SDCKR = 0 to 4 (0-2, 1-2.5,2 - 3, 3- 3.5, 4-4)
// Indiv = True or False(0- False, 1 - True

int main( void )
{
	/* Begin adding your custom code here */
	initPLL_2147x(16,0,0,false);
//	initPLL_2147x_15000020_workaround(16,0,0,false);
	interrupt(SIG_GPTMR0, General_Purpose_Timer0_Isr);
	
	InitSRU();
	
	InitTimers();
	BlinkLED();

}


void BlinkLED(void )
{
	int i;
	
	asm("bit set FLAGS  FLG4O | FLG5O | FLG6O ;");
	asm("nop;");
	asm("bit clr FLAGS  FLG4 | FLG5 | FLG6;");
	asm("nop;");
	asm("nop;");
	
	while(1)
	{
		for(i = 0; i < 0xFFFFFF; i++ );
	
		if( toggle_flag == 0)
		{
			SRU (LOW, DAI_PB03_I);
			SRU (HIGH, DAI_PB04_I);
			SRU (HIGH, DAI_PB15_I);
			SRU (HIGH, DAI_PB16_I);
			SRU (HIGH, DAI_PB17_I);
			
			toggle_flag = 1;
		}
		else
		{
			SRU (HIGH, DAI_PB03_I);
			SRU (LOW, DAI_PB04_I);
			SRU (LOW, DAI_PB15_I);
			SRU (LOW, DAI_PB16_I);
			SRU (LOW, DAI_PB17_I);
			
			toggle_flag = 0;
		}
		
		asm("bit tgl FLAGS  FLG4 | FLG5 | FLG6 ;");
		asm("nop;");
	}
}	

void InitTimers(void)
{

	// Configure Timer 1 in PWM output mode.
	*pTM1CTL = TIMODEPWM | PULSE | PRDCNT;
	*pTM1PRD = 0x1000;
	*pTM1W = 0xA00;
		
	// Enable Timer 0 in Width capture mode
	*pTM0CTL = TIMODEW | PULSE | PRDCNT | IRQEN;
	*pTMSTAT = TIM0EN | TIM1EN;
		
}

void General_Purpose_Timer0_Isr(int dummy)
{
	count++;
	Period_measured = *pTM0PRD;
	Count_measured = *pTM0W;
	
	*pTMSTAT = TIM0IRQ;

}
